const std = @import("std");
const file_op = @import("file_op.zig");
const user_int = @import("interaction.zig");

pub fn main() !void {
    const filename = "todo-db.txt";
    var gpa = std.heap.GeneralPurposeAllocator(.{}){};
    defer _ = gpa.deinit();
    const allocator = gpa.allocator();

    var file_res = file_op.readTasksFromFile(allocator, filename) catch |err| {
        std.debug.print("Failed read or create file:\n{}\n", .{err});
        return err;
    };

    defer {
        for (file_res.tasks.items) |task| {
            allocator.free(task);
        }
        file_res.tasks.deinit();
        file_res.file.close();
    }

    user_int.userInteraction(allocator, &file_res.tasks) catch |err| {
        std.debug.print("User Interaction error:\n{}\n", .{err});
        return err;
    };

    file_op.writeTasksToFile(file_res) catch |err| {
        std.debug.print("Error while writing data to file:\n{}\n", .{err});
    };
}
